<template>
  <div class="container shadow-2 bg-white" style="color: #757575">
    <ri-header :menu="3"></ri-header>
    <div>
      <div>
        <input-section
          @start-btn="startBtn"
          @reset-start-btn="resetStartBtn"
          @change-integration-type="changeIntegrationType"
        />
      </div>
    </div>
    <div v-if="showResultAfterStartBtn" class="">
      <div>
        <hr />
        <div>
          <four-bar
            :name="fourBarName"
            :type="input.type"
            :year="input.year.max"
            :data="fourBarData"
            :partner="fourBarNamePatner"
          ></four-bar>
        </div>
        <hr />
        <select-desired
          :input="input"
          :disaggregation="input.disaggregation"
          @change-disaggregation="changeDisaggraegation"
        ></select-desired>
      </div>
      <div v-show="input.disaggregation == 'country'">
        <main-linechart
          :data="countryFullList"
          :report="countryReportList"
          :input="input"
        ></main-linechart>
        <spider-web
          :input="input"
          :data="countryFullList"
          :report="countryReportList"
        ></spider-web>
        <div class="q-py-lg" style="background: #ededed" align="center">
          <div class="btnOutGreen" @click="changeDisaggregationToDimension()">
            Explore integration by dimension
          </div>
        </div>
      </div>
      <!-- by dimension  -->
      <div v-show="input.disaggregation == 'dimension'">
        <line-chart-dimension
          :data="countryFullList"
          :input="input"
          :report="countryReportList"
        ></line-chart-dimension>
        <dimension-tab
          :input="input"
          :data="countryFullList"
          :report="countryReportList"
        ></dimension-tab>
        <div class="q-pb-lg" style="background: #ededed" align="center">
          <div class="btnOutGreen" @click="changeDisaggregationToEco()">
            Explore integration by economy
          </div>
        </div>
      </div>
    </div>
    <my-footer></my-footer>
  </div>
</template>

<script>
import riHeader from "../components/ri/main/ri_header";
import myFooter from "../components/ri_footer";
import inputSection from "../components/ri/buildyourown/input_section";
import fourBar from "../components/ri/buildyourown/ri_fourbar";
import selectDesired from "../components/ri/main/ri_select_desired_level";
import mainLinechart from "../components/ri/buildyourown/main_linechart";
import spiderWeb from "../components/ri/buildyourown/spiderweb";
import lineChartDimension from "../components/ri/buildyourown/linechart_by_dimension";
import dimensionTab from "../components/ri/buildyourown/datatab_dimension";

export default {
  components: {
    riHeader,
    myFooter,
    inputSection,
    fourBar,
    selectDesired,
    mainLinechart,
    spiderWeb,
    lineChartDimension,
    dimensionTab,
  },
  data() {
    return {
      countryFullList: [],
      countryReportList: [],
      input: {
        partner: [],
        reporting: [],
        year: {
          min: 2012,
          max: 2020,
        },
        type: "Sustainable",
        disaggregation: "country",
        dimensionPicked: [],
      },
      showResultAfterStartBtn: false,

      dataAvailCircleChart: {
        showChart: false,
        score: 0,
      },
      fourBarName: "Your group",
      fourBarData: [],
      fourBarNamePatner: "with your group of partners",
    };
  },
  methods: {
    startBtn(inputSend) {
      this.showResultAfterStartBtn = true;
      this.countryFullList = inputSend.countryFullList;
      this.countryReportList = inputSend.reportingList;
      this.input = inputSend.input;
      this.calFourBarChart();
    },
    resetStartBtn() {
      this.showResultAfterStartBtn = false;
    },
    convertDimensionToArray(dim) {
      let dimGet = dim.map((x) => x.picked);
      let dimReturn = [];
      dimGet.forEach((item, index) => {
        if (item) {
          dimReturn.push(index + 1);
        }
      });
      return dimReturn;
    },
    async calFourBarChart() {
      let labelName = "Your Group";

      if (this.input.reporting.length == 1) {
        labelName = this.input.reporting[0].label;
      }

      // if (this.input.reporting.length == 1) {
      //   labelName = this.input.reporting[0].label;
      // }

      this.fourBarName = labelName;
      let labelPartner = "with your group of partners";
      if (this.input.partner.length == 1) {
        labelPartner = "with " + this.input.partner[0].label;
      }
      this.fourBarNamePatner = labelPartner;
      let dimUse = this.convertDimensionToArray(this.input.dimensionPicked);
      let data = {
        name: labelName,
        reporting: this.countryReportList.map((x) => x.iso),
        partner: this.countryFullList.map((x) => x.iso),
        year: this.input.year.max,
        type: this.input.type,
        dimension: dimUse,
      };

      let url = this.ri_api + "buildyourown/fivebar_onlyyourgroup_build.php";
      let res = await axios.post(url, JSON.stringify(data));

      let rawData = res.data;
      let score = 0;
      let countPair = 0;
      let pairScore = [];
      this.fourBarData = [];
      let dimPass = data.dimension.length / 2;
      // cal only dim pass rule of 50%
      data.reporting.forEach((reporting) => {
        data.partner.forEach((partner) => {
          let sum = 0;
          let dataTemp = rawData.filter(
            (x) => x.reporter == reporting && x.partner == partner
          );
          if (dataTemp.length >= dimPass) {
            dataTemp.forEach((eachDim) => (sum += Number(eachDim.score)));
            sum /= dataTemp.length;
            countPair++;
            let obTemp = {
              reporter: reporting,
              partner: partner,
              score: Number(sum.toFixed(2)),
            };
            pairScore.push(obTemp);
          } else {
            sum = 0;
          }
          score += sum;
        });
      });
      pairScore.sort((a, b) => b.score - a.score);
      score /= countPair;
      if (pairScore.length > 4) {
        for (let i = 0; i < 4; i++) {
          let nameTemp =
            this.showReportFullName(pairScore[i].reporter) +
            " - " +
            this.showPartnerFullName(pairScore[i].partner);
          this.fourBarData.push({
            name: nameTemp,
            value: Number(pairScore[i].score.toFixed(2)),
            own: false,
          });
        }
      } else {
        for (let i = 0; i < pairScore.length; i++) {
          let nameTemp =
            this.showReportFullName(pairScore[i].reporter) +
            " - " +
            this.showPartnerFullName(pairScore[i].partner);
          this.fourBarData.push({
            name: nameTemp,
            value: Number(pairScore[i].score.toFixed(2)),
            own: false,
          });
        }
      }
      this.fourBarData.push({
        name: labelName,
        value: Number(score.toFixed(2)),
        own: true,
      });
      this.fourBarData.sort((a, b) => b.value - a.value);
    },
    changeIntegrationType(integrationType) {
      this.input.type = integrationType;
    },
    changeDisaggraegation(type) {
      this.input.disaggregation = type;
    },
    showReportFullName(isoName) {
      return this.countryReportList.filter((x) => x.iso == isoName)[0].label;
    },
    showPartnerFullName(isoName) {
      return this.countryFullList.filter((x) => x.iso == isoName)[0].label;
    },
    changeDisaggregationToDimension() {
      this.input.disaggregation = "dimension";
      window.scrollTo(0, 1400);
    },
    changeDisaggregationToEco() {
      this.input.disaggregation = "country";
      window.scrollTo(0, 1400);
    },
  },
};
</script>

<style lang="scss" scoped>
.btnOutGreen {
  cursor: pointer;
  width: 340px;
  height: 35px;
  line-height: 30px;
  border: 3px solid #2d9687;
  border-radius: 5px;
  font-size: 14px;
}
.footer-bg {
  background-image: url("../../public/footer.jpg");
  background-size: inherit;
  background-position: bottom;
}
</style>
